# -----------------------------------------------------------------------------
package Etc_Group;
# -----------------------------------------------------------------------------

use strict;



# -----------------------------------------------------------------------------
# -- CONSTRUCTOR :
# -----------------------------------------------------------------------------

sub new() {

    my $class  = shift;
    my $devel  = shift;
    my $config = shift;

    my $self = { };

    bless($self, $class);

    open(GROUP,"<" . $config->etc_group()) 
        || $devel->die("Cannot open " . $config->etc_group());

    while (my $textline = <GROUP>) {

#       $textline =~ s/\n//g;
#       $textline =~ s/\r//g;
        $textline =~ s/\s//g;
        
        my ($group, undef, $gid, $users) = split(/\:/, $textline);

        $self->{$group}->{GID}   = $gid;
        $self->{$group}->{USERS} = $users;
      }

    close(GROUP);

    return $self;
  }

# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------

# -- is the given user in the given group?

sub member () {
    my $self  = shift;
    my $group = shift;
    my $uname = shift;

    if (   ($self->{$group}->{USERS} =~ m/^$uname/)
        || ($self->{$group}->{USERS} =~ m/\,$uname\,/)
        || ($self->{$group}->{USERS} =~ m/\,$uname$/)  ) {
        return 1;
      }
    else {
        return 0;
      }
  }

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
