package Logs;

use strict;

# -----------------------------------------------------------------------------

sub new() {

  my $class  = shift;
  my $devel  = shift;
  my $config = shift;

    my $self = { };

    bless($self, $class);

    $self->{DEVEL}   = $devel;
    $self->{CONFIG}  = $config;
    $self->{LOGFILE} = $config->log_file();

    return $self;
  }

# -----------------------------------------------------------------------------
# -- LOG TO BASE 10 :
# -----------------------------------------------------------------------------

sub append() {
    my $self   = shift;
    my $string = shift;

    open(LOG, ">>" . $self->{CONFIG}->log_file()) 
        || $self->{DEVEL}->die("Can't append to log!");

    print LOG "\n"
#        . mod_caller() 
#        . "::" 
#        . sub_caller()
#        . "  " 
        . $string;

    close(LOG);
  }


# -----------------------------------------------------------------------------
# -- ACCOUNT CREATION LOG :
# -----------------------------------------------------------------------------

sub append_new_acc() {
    my $self     = shift;
    my $username = shift;

    open(LOG, ">>" . $self->{CONFIG}->acc_cr_log_file) 
        || $self->{DEVEL}->die("Can't append to account-creation log!");

    print LOG "\n " . time . " \t : $username";
    close(LOG);
  }


# -----------------------------------------------------------------------------
# -- TOOLKIT :
# -----------------------------------------------------------------------------

#sub mod_caller() {
#    my $module = caller(2);
#    return $module;
#  }

#sub sub_caller() {
#    my $subroutine;
#
#    (undef, undef, undef, $subroutine) = caller(2);
#
#    return $subroutine;
#  }

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
